package cn.estsh.i3plus.ext.mes.apiservice.serviceimpl.report;

import cn.estsh.i3plus.ext.mes.api.busi.report.IMesWorkCellScanMonitorLogService;
import cn.estsh.i3plus.ext.mes.apiservice.utils.MesException;
import cn.estsh.i3plus.ext.mes.pojo.model.report.MesWorkCellScanMonitorConditionModel;
import cn.estsh.i3plus.ext.mes.pojo.model.report.MesWorkCellScanMonitorLogModel;
import cn.estsh.i3plus.ext.mes.pojo.util.MesExtConstWords;
import cn.estsh.i3plus.pojo.base.bean.DdlPackBean;
import cn.estsh.i3plus.pojo.base.tool.DdlPreparedPack;
import cn.estsh.i3plus.pojo.mes.bean.MesWcEquipment;
import cn.estsh.i3plus.pojo.mes.repository.MesWcEquipmentRepository;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.util.CollectionUtils;
import org.springframework.util.StringUtils;

import java.util.List;

@Service
public class MesWorkCellMonitorLogService implements IMesWorkCellScanMonitorLogService {

    @Autowired
    private MesWcEquipmentRepository equipmentRepository;

    @Override
    public List<MesWorkCellScanMonitorLogModel> queryWorkCellScanMonitorLogList(MesWorkCellScanMonitorConditionModel conditionModel) {

        List<MesWcEquipment> wcEquipmentList = beforeCheckCondition(conditionModel);

        List<MesWorkCellScanMonitorConditionModel> conditionModelList = getConditionModelList(conditionModel, wcEquipmentList);

        return null;
    }

    private List<MesWcEquipment> beforeCheckCondition(MesWorkCellScanMonitorConditionModel conditionModel) {

        if (StringUtils.isEmpty(conditionModel.getWorkCellCode()) && StringUtils.isEmpty(conditionModel.getEquipmentCode())) MesException.throwBusiException("请输入工位代码或者设备代码进行查询!");

        if (!StringUtils.isEmpty(conditionModel.getWorkCellCode()) && StringUtils.isEmpty(conditionModel.getWorkCenterCode())) MesException.throwBusiException("查询参数异常,工位[%s]未携带生产线查询条件!");

        List<MesWcEquipment> wcEquipmentList = getEquipmentList(conditionModel);
        if (!StringUtils.isEmpty(conditionModel.getWorkCellCode()) && !StringUtils.isEmpty(conditionModel.getEquipmentCode()) &&
                CollectionUtils.isEmpty(wcEquipmentList)) MesException.throwBusiException("生产线[%s]工位[%s]未关联设备[%s]", conditionModel.getWorkCenterCode(), conditionModel.getWorkCellCode(), conditionModel.getEquipmentCode());

        if (!StringUtils.isEmpty(conditionModel.getWorkCellCode()) && StringUtils.isEmpty(conditionModel.getEquipmentCode()) &&
                CollectionUtils.isEmpty(wcEquipmentList)) MesException.throwBusiException("生产线[%s]工位[%s]未关联设备信息", conditionModel.getWorkCenterCode(), conditionModel.getWorkCellCode());

        if (StringUtils.isEmpty(conditionModel.getWorkCellCode()) && !StringUtils.isEmpty(conditionModel.getEquipmentCode()) &&
                CollectionUtils.isEmpty(wcEquipmentList)) MesException.throwBusiException("设备[%s]未关联工位", conditionModel.getEquipmentCode());

        return wcEquipmentList;
    }

    private List<MesWcEquipment> getEquipmentList(MesWorkCellScanMonitorConditionModel conditionModel) {
        DdlPackBean packBean = DdlPackBean.getDdlPackBean(conditionModel.getOrganizeCode());
        DdlPreparedPack.getStringEqualPack(conditionModel.getWorkCenterCode(), MesExtConstWords.WORK_CENTER_CODE, packBean);
        DdlPreparedPack.getStringEqualPack(conditionModel.getWorkCellCode(), MesExtConstWords.WORK_CELL_CODE, packBean);
        DdlPreparedPack.getStringEqualPack(conditionModel.getEquipmentCode(), MesExtConstWords.EQUIPMENT_CODE, packBean);
        return equipmentRepository.findByHqlWhere(packBean);
    }

    private List<MesWorkCellScanMonitorConditionModel> getConditionModelList(MesWorkCellScanMonitorConditionModel conditionModel, List<MesWcEquipment> wcEquipmentList) {
        return null;
    }


}
